#include <bits/stdc++.h>

using namespace std;

#define nl '\n'

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long int n,q;
        cin>>n>>q;


    vector<long long int> a(n);
    long long int bits[n][63];
        for(long long int i =0;i<n;i++){
            cin>>a[i];
        }
       long long int psum[n+1][63];
       for(long long int i =0;i<=n;i++){
        for(long long int j =0;j<63;j++)psum[i][j]=0;
       }

        for(long long int i =0;i<n;i++){

            for(long long int j =0;j<63;j++){
                long long int k = 1LL<<j;
                if((a[i]&k)==0)bits[i][j]=0;
                else bits[i][j]=1;
            }


        }


        for(long long int i =1;i<=n;i++){
            for(long long int j = 0;j<63;j++){
                psum[i][j]=psum[i-1][j]+bits[i-1][j];
            }
        }




        vector<long long int> ans(q);

        for(long long int i =0;i<q;i++){
            long long int l,r;
            cin>>l>>r;
            //l-=1;r-=1;
            long long int p = 62;
            long long int s = 0;
            while(s==0){
                s=psum[r][p]-psum[l-1][p];
                p-=1;
            }
            ans[i]=s;
        }
        for(long long int i =0;i<q;i++)cout<<ans[i]<<nl;
        //cout<<ans[q-1];


    return 0;
}